unit HiPerfTime;

interface
uses
  Windows, Messages, SysUtils, Classes, Dialogs, OpenGL12, Math;

type
  //Struktur fr 64 Bit - Reals
  TLargeInteger = record
                    case Integer of
                      0: ( LowPart  : DWORD;
                           HighPart : LongInt);
                      1: ( QuadPart : LONGLONG);
                  end;

  //Struktur, die Zeiten festhlt
  TTimeCountStruct = record
                       InitialCount : TLargeInteger;
                     end;

procedure BeginCounting(var Counter : TTimeCountStruct);
function  GetTimeNeeded(    Counter : TTimeCountStruct) : Single;

implementation
var
  Freq : TLargeInteger;

procedure BeginCounting(var Counter : TTimeCountStruct);
begin
  //Holen von Frequenz und aktuellem Counter
  QueryPerformanceCounter(Counter.InitialCount.QuadPart);
end;

function  GetTimeNeeded(    Counter : TTimeCountStruct) : Single;
var
  EndCount : TLargeInteger;
begin
  //Holen des aktuellen Counters und gebrauchte Zeit berechnen
  QueryPerformanceCounter(EndCount.QuadPart);
  with Counter do
  begin
    Result := (EndCount.QuadPart - InitialCount.QuadPart)/Freq.QuadPart
  end
end;

begin
  if not QueryPerformanceFrequency(Freq.QuadPart) or (Freq.QuadPart = 0) then
  begin
    MessageDlg('Kein Performance Counter!', mtError, [mbOk], 0);
    ExitProcess(1000)
  end
end.
