unit joystick;

{
****************************[ Joystick Helper Unit ]****************************

        visit us at http://dgl.quellcodes.de/

 Have Fun!
     Delphic (redsoftware@gmx.de)

     Last Update 2002-10-08
}

interface
uses
  Windows, MMSystem;

type
  TJoystick = record
                x,y : Single;
                Buttons : Array[0..3] of Boolean;
                MaxX, MinX, MaxY, MinY : Integer;
                JoystickID : Integer;
              end;


procedure InitJoystick(var Joystick : TJoystick; const ID : Integer);
procedure QuitJoystick(Joystick : TJoystick);

procedure PollJoystick(var JoyStick : TJoyStick);

implementation

procedure InitJoystick(var Joystick : TJoystick; const ID : Integer);
var
  JoyCaps : TJoyCaps;
begin
  joyGetDevCaps(ID, @JoyCaps, SizeOf(JoyCaps));
  Joystick.JoystickID := ID;
  Joystick.MaxX := JoyCaps.wXmax;
  Joystick.MaxY := JoyCaps.wYmax;
  Joystick.MinX := JoyCaps.wXmin;
  Joystick.MinY := JoyCaps.wYmin;
end;

procedure QuitJoystick(Joystick : TJoystick);
begin
end;

procedure PollJoystick(var JoyStick : TJoyStick);
var
  JoyInfoEx : TJoyInfoEx;
  I : Integer;
begin
  FillChar(JoyInfoEx, SizeOf(JoyInfoEx), 0);
  JoyInfoEx.dwFlags := JOY_RETURNX or JOY_RETURNY or JOY_RETURNBUTTONS;
  JoyInfoEx.dwSize := SizeOf(JoyInfoEx);
  joyGetPosEx(Joystick.JoystickID, @JoyInfoEx);
  JoyStick.X := (JoyInfoEx.wXpos - JoyStick.MinX)/ (JoyStick.MaxX - JoyStick.MinX);
  JoyStick.Y := (JoyInfoEx.wYpos - JoyStick.MinY)/ (JoyStick.MaxY - JoyStick.MinY);
  for i := 0 to 3 do
    JoyStick.Buttons[i] := (JoyInfoEx.wButtons and (JOY_BUTTON1 + i)) = (JOY_BUTTON1 + i)
end;

end.
