unit template_fullscreen;
{
********************[ Delphi OpenGL Template fr eine VCL-Szene ]***************

 Unit zum wechseln zwischen Vollbild- und Fenstermodus fr VCL Programme

        visit us at http://dgl.quellcodes.de/

 Have Fun!
     Delphic (redsoftware@gmx.de)

     Last Update 2002-09-16
}

interface

const
  FWidth = 800;
  FHeight = 600;
  FPixelDepth = 32;

procedure InitFullscreenMode;
procedure LeaveFullscreenMode;
procedure SwichFullscreenMode;
function IsFullscreenMode : Boolean;

implementation
uses
  Forms, Windows, Messages;

var
  Fullscreen : Boolean;

procedure InitFullscreenMode;
////////////////////////////////////////////////////////////////////////////////
// InitFullscreen
//------------------------------------------------------------------------------
// Aktiviert den Vollbildmodus
//------------------------------------------------------------------------------
// Parameter: -
// Rckgabe : -
////////////////////////////////////////////////////////////////////////////////
var
  dmScreenSettings : DevMode;

begin
  if Fullscreen then Exit;

  ZeroMemory(@dmScreenSettings, SizeOf(dmScreenSettings));
  with dmScreenSettings do begin              // Bildschirm Einstellungen werden festgelegt
    dmSize       := SizeOf(dmScreenSettings);
    dmPelsWidth  := FWidth;                    // Fenster Breite
    dmPelsHeight := FHeight;                   // Fenster Hhe
    dmBitsPerPel := FPixelDepth;               // Farbtiefe (32bit etc)
    dmFields     := DM_PELSWIDTH or DM_PELSHEIGHT or DM_BITSPERPEL;
  end;

  // Bilschirm Modus auf Vollbild setzen
  if (ChangeDisplaySettings(dmScreenSettings, CDS_FULLSCREEN) = DISP_CHANGE_FAILED) then
  begin
    MessageBox(0, 'Konnte Vollbildmodus nicht aktivieren', 'Error', MB_OK or MB_ICONERROR);
    Fullscreen := False;
    Exit
  end;

  with Application.MainForm do
  begin
    SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) AND NOT (WS_CAPTION or WS_THICKFRAME));
    Width := FWidth;
    Height := FHeight;
    SetWindowPos(Handle, HWND_TOP, 0,0, FWidth, FHeight, 0);
    Refresh
  end;
  Fullscreen := True
end;

procedure LeaveFullscreenMode;
////////////////////////////////////////////////////////////////////////////////
// LeaveFullscreenMode
//------------------------------------------------------------------------------
// Verlsst den Vollbildmodus
//------------------------------------------------------------------------------
// Parameter: -
// Rckgabe : -
////////////////////////////////////////////////////////////////////////////////
begin
  ChangeDisplaySettings(devmode(nil^),0);
  Fullscreen := False
end;

function IsFullscreenMode : Boolean;
////////////////////////////////////////////////////////////////////////////////
// IsFullscreenMode
//------------------------------------------------------------------------------
// Gibt zurck, ob sich das Programm im Vollbildmodus befindet, oder nicht
//------------------------------------------------------------------------------
// Parameter: -
// Rckgabe : -
////////////////////////////////////////////////////////////////////////////////
begin
  Result := Fullscreen
end;

procedure SwichFullscreenMode;
begin
  if Fullscreen then
  begin
    LeaveFullscreenMode;
    with Application.MainForm do
    begin
      SetWindowLong(Handle, GWL_STYLE, GetWindowLong(Handle, GWL_STYLE) OR (WS_CAPTION or WS_THICKFRAME));
      SetWindowPos(Handle, HWND_TOP, 0,0, 640, 480, SWP_SHOWWINDOW);
      ClientWidth := 600;
      ClientHeight := 400
    end
  end
  else
    InitFullscreenMode
end;


initialization
  Fullscreen := False;

end.
